#ifndef _OF_RECORD_MOVIE
#define _OF_RECORD_MOVIE

#include "ofMain.h"
#include "ofConstants.h"
#include "Encoder.h" 

#include <iostream>
using namespace omnividea::fobs;
using namespace std;




//---------------------------------------------

class ofRecordMovie {
	
	public:
							ofRecordMovie(const char *filename);
							~ofRecordMovie();

		ReturnCode 			chooseVideoCodec(int width, int height, double bitRate, double frameRate, char *fcc);
		ReturnCode 			chooseAudioCodec(int samplesPerSec, int channels, double bitRate, char *fcc);
		ReturnCode 			chooseFormat(char *fcc);
		ReturnCode			startRecord(void);
		ReturnCode 			encodeFrame();
		void				abort();
		void				quit();
		
	private:
		////---------------------------
		
		Encoder				*e;
		ofImage				screenpix;
		char *				outputFile;
		int 				width;
		int					height;
		
		bool 				customVideoSettings;
		int 				vWidth;
		int 				vHeight;
		double 				vBitRate;
		double				vFrameRate;
		int 				vCounter;
		int 				aCounter;

		bool 				customAudioSettings;
		int 				aSamplesPerSec;
		int					aChannels;
		double 				aBitRate;

		char 				*vCodec;
		char 				*aCodec;
		char				*mFormat;
		
		bool    			abortSignal;		
					
}; 
#endif
